VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Channel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
  Option Explicit
  

  Private resistance As Integer
  Private value As Integer
  Private maxVoltage As Double
  Private isRecording As Boolean
  Private hideVariations As Boolean
  
  
  Private unit As String
  Private minRange As Double
  Private maxRange As Double
  
  
  Public Sub saveObject(prefix As Integer)
    SaveSetting "IntelliDatalogger", "Settings", "Resistance" & prefix, resistance
    SaveSetting "IntelliDatalogger", "Settings", "Maxvoltage" & prefix, maxVoltage
    SaveSetting "IntelliDatalogger", "Settings", "hideVariations" & prefix, hideVariations
    SaveSetting "IntelliDatalogger", "Settings", "Unit" & prefix, unit
    SaveSetting "IntelliDatalogger", "Settings", "minRange" & prefix, minRange
    SaveSetting "IntelliDatalogger", "Settings", "maxRange" & prefix, maxRange
  End Sub
  
  
  Public Sub loadObject(prefix As Integer)
    resistance = GetSetting("IntelliDatalogger", "Settings", "Resistance" & prefix, 225)
    maxVoltage = GetSetting("IntelliDatalogger", "Settings", "Maxvoltage" & prefix, 5)
    hideVariations = GetSetting("IntelliDatalogger", "Settings", "hideVariations" & prefix, False)
    unit = GetSetting("IntelliDatalogger", "Settings", "Unit" & prefix, "%LEL")
    minRange = GetSetting("IntelliDatalogger", "Settings", "minRange" & prefix, 0)
    maxRange = GetSetting("IntelliDatalogger", "Settings", "maxRange" & prefix, 100)
  End Sub
  
  
  Public Sub setHideVariations(enabled As Boolean)
    hideVariations = enabled
  End Sub
  
  Public Function isHideVariationsIsEnabled() As Boolean
    isHideVariationsIsEnabled = hideVariations
  End Function
  
  
  
  
  
  Public Sub setIsRecording(enabled As Boolean)
    isRecording = enabled
  End Sub
  
  Public Function getIsRecording() As Boolean
    getIsRecording = isRecording
  End Function
  
  
  
  Public Sub setUnit(aUnit As String)
    unit = aUnit
  End Sub
  
  Public Function getUnit() As String
    getUnit = unit
  End Function
  
  Public Sub setMinRange(aMinRange As Double)
      minRange = aMinRange
  End Sub
  
  Public Sub setMaxRange(aMaxRange As Double)
      maxRange = aMaxRange
  End Sub
  
  Public Function getMinRange() As Double
      getMinRange = minRange
  End Function
  
  Public Function getMaxRange() As Double
      getMaxRange = maxRange
  End Function
  
  
  
  
  
  
  Public Sub setMaxVoltage(aMaxVoltage As Double)
    maxVoltage = aMaxVoltage
  End Sub
  
  Public Function getMaxVoltage() As Double
    getMaxVoltage = maxVoltage
  End Function
  
  
  
  Public Sub setValue(aValue As Integer)
    value = aValue
  End Sub
  
  
  Public Function getValue() As Integer
    getValue = value
  End Function
  
  
  Public Function getResistance() As Double
    getResistance = resistance
  End Function
  
  
  Public Sub setResistance(aResistance As Integer)
    resistance = aResistance
  End Sub
  
  
  ' calculate the current
  Public Function getCurrent() As Double
    getCurrent = Format((((getValue() / 255) * getMaxVoltage()) / getResistance()) * 1000, "0.0")
  End Function
  
  Public Function getCurrentStr() As String
    getCurrentStr = getCurrent & " mA"
  End Function
  
  
  
  ' show the real values
  Public Function getConversionValue() As Double
    '16 mA = maxRange - minRange
    '1  mA = (maxRange - minRange)/16
    getConversionValue = Format((getCurrent() - 4) * ((getMaxRange() - getMinRange()) / 16), "0.0")
  End Function
  
  
  Public Function getConversionValueStr(showErrors As Boolean) As String
    If showErrors Then
      ' Show underrange and overrange errors)
      If getCurrent < 4 Then
        getConversionValueStr = "Underrange (" & getCurrent & " mA)"
      ElseIf getCurrent > 20 Then
        getConversionValueStr = "Overrange (" & getCurrent & " mA)"
      Else
        getConversionValueStr = getConversionValue() & " " & getUnit()
      End If
    Else
      ' Don't show any errors (show value as it is)
      getConversionValueStr = getConversionValue() & " " & getUnit()
    End If
  End Function



